---
obj: application
repo: https://github.com/WerWolv/ImHex
website: https://imhex.werwolv.net
flatpak-id: net.werwolv.ImHex
rev: 2024-07-14
---

# ImHex
A Hex Editor for Reverse Engineers, Programmers and people who value their retinas when working at 3 AM

This [repository](https://github.com/WerWolv/ImHex-Patterns) contains a database for files to use with the ImHex Hex Editor. It currently contains
- Patterns - Binary Format definitions for the Pattern Language
- Pattern Libraries - Libraries that make using the Pattern Language easier
- Magic Files - Custom magic file definitions for the use with libmagic
- Encodings - Custom encodings in the .tbl format
- Data Processor Nodes - Custom nodes made for ImHex's Data Processor
- Themes - Custom themes for ImHex
- Constants - Constants definition files
- Scripts - Various scripts to generate code or automate some tasks
- Yara - Custom Yara rules

![Screenshot](./imhex.avif)

## Features
- Byte patching
- Patch management
- Infinite Undo/Redo
- "Copy bytes as..."
  - Bytes
  - Hex string
  - C, C++, C#, Rust, Python, Java & JavaScript array
  - ASCII-Art hex view
  - HTML self-contained div
- Simple string and hex search
- Goto from start, end and current cursor position
- Colorful highlighting
- Displaying data as a list of many different types
  - Hexadecimal integers (8, 16, 32, 64 bit)
  - Signed and unsigned decimal integers (8, 16, 32, 64 bit)
  - Floats (16, 32, 64 bit)
  - RGBA8 Colors
  - HexII
  - Binary
- Decoding data as ASCII and custom encodings
- Base64 files
- IPS and IPS32 patches
- Markdown reports
- Node-based data pre-processor
  - Modify, decrypt and decode data before it's being displayed in the hex editor
  - Modify data without touching the underlying source
  - Support for adding custom nodes  
- Support for searching the entire file or only a selection
- String extraction
- Sequence search
- Regex search
- Binary Pattern
- Numeric Value search
- Compare data of different data sources
- Difference highlighting
- Table view of differences
- File magic-based file parser and MIME type database
- Byte type distribution graph
- Entropy graph
- Highest and average entropy
- Encrypted / Compressed file detection
- Digram and Layered distribution graphs
- Itanium, MSVC, Rust and D-Lang demangler based on LLVM
- ASCII table
- Regex replacer
- Mathematical expression evaluator (Calculator)
- Graphing calculator
- Hexadecimal Color picker with support for many different formats
- Base converter
- Byte swapper
- UNIX Permissions calculator
